searchData={"content_type":"text/markdown","items":[{"doc":"This module is the main process which listens to file changes,\ntriggers commands and notifications","ref":"ExGuard.html","title":"ExGuard","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"ExGuard.html#child_spec/1","title":"ExGuard.child_spec/1","type":"function"},{"doc":"Holds the ExGuard configurations during run time.","ref":"ExGuard.Config.html","title":"ExGuard.Config","type":"module"},{"doc":"Returns agent based on guard title","ref":"ExGuard.Config.html#get_guard/1","title":"ExGuard.Config.get_guard/1","type":"function"},{"doc":"","ref":"ExGuard.Config.html#get_guards/0","title":"ExGuard.Config.get_guards/0","type":"function"},{"doc":"Loads ExGuard config file","ref":"ExGuard.Config.html#load/1","title":"ExGuard.Config.load/1","type":"function"},{"doc":"Given the path, returns matched guard configs.\n\nIn case that a {regex, func} is given to watch, this function also executes\nthe func and returns list of files","ref":"ExGuard.Config.html#match_guards/1","title":"ExGuard.Config.match_guards/1","type":"function"},{"doc":"Puts guard into agent","ref":"ExGuard.Config.html#put_guard/2","title":"ExGuard.Config.put_guard/2","type":"function"},{"doc":"Starts agent that keeps the configurations","ref":"ExGuard.Config.html#start_link/0","title":"ExGuard.Config.start_link/0","type":"function"},{"doc":"Users use functions in this module to build config files.\n\n    guard(\"test\")\n    |> command(\"mix text --color\")\n    |> watch(~r{\\.(ex|exs)$})\n    |> notification(:auto)","ref":"ExGuard.Guard.html","title":"ExGuard.Guard","type":"module"},{"doc":"Sets command for given guard config.\n\n    guard(\"test\")\n    |> command(\"mix text --color\")","ref":"ExGuard.Guard.html#command/2","title":"ExGuard.Guard.command/2","type":"function"},{"doc":"Executes the command for a guard config.\n\nIf files is a list, append them to guard.cmd and executes it.","ref":"ExGuard.Guard.html#execute/1","title":"ExGuard.Guard.execute/1","type":"function"},{"doc":"Creates ExGuard config.\n\n    guard(\"test\")\n\nOptions:\n\n  * `:run_on_start`, set this option If you want to run the command when `mix guard` has been executed\n  * `:umbrella_app`, set this option If you are running guard on the main directory of an umbrella project and using `watch` command to match changed filed with test\n\n    guard(\"test\", run_on_start: true, umbrella_app: true)","ref":"ExGuard.Guard.html#guard/2","title":"ExGuard.Guard.guard/2","type":"function"},{"doc":"It can be used to exclude files and directories from the set of files being watched.\n\n    guard(\"text files\")\n    |> ignore(~r/\\.txt$/)","ref":"ExGuard.Guard.html#ignore/2","title":"ExGuard.Guard.ignore/2","type":"function"},{"doc":"Sets notification for given guard config.\nBy default notification is on.\n\n    guard(\"test\")\n    |> notification(:auto)\n\nTo turn off the notification set it to `:off`\n    guard(\"not notification\")\n    |> notification(:off)","ref":"ExGuard.Guard.html#notification/2","title":"ExGuard.Guard.notification/2","type":"function"},{"doc":"notifies the result","ref":"ExGuard.Guard.html#notify/1","title":"ExGuard.Guard.notify/1","type":"function"},{"doc":"Sets watch pattern for given guard config.\n\nTo watch all Elixir and Erlang files set:\n    guard(\"Elixir/Erlang files\")\n    |> watch(~r{\\\\.(erl|ex|exs|eex|xrl|yrl)\\\\z}i)\n\nTo only execute the command for specific files use:\n    guard(\"execute specific tests\")\n    |> watch({~r{lib/(? .+)/(? .+).ex$}, fn(m) -> \"test/#{m[\"dir\"]}/#{m[\"file\"]}_test.exs\" end})","ref":"ExGuard.Guard.html#watch/2","title":"ExGuard.Guard.watch/2","type":"function"},{"doc":"Notify given message","ref":"ExGuard.Notifier.html","title":"ExGuard.Notifier","type":"module"},{"doc":"Notifies message through available notifiers.\n\n    ExGuard.Notifier.notify(title: \"Test\", message: \"hello\", status: :ok)\n\n`:status` can be these values:\n  - `:ok`\n  - `:error`\n  - `:pending`","ref":"ExGuard.Notifier.html#notify/1","title":"ExGuard.Notifier.notify/1","type":"function"},{"doc":"ExGuard automates various tasks by running custom rules whenever file or directories are modified.","ref":"Mix.Tasks.Guard.html","title":"mix guard","type":"task"},{"doc":"usage: mix guard [--config=.exguard.exs]\n    help: mix help guard","ref":"Mix.Tasks.Guard.html#module-usage","title":"Usage - mix guard","type":"task"},{"doc":"add `ex_guard` to `mix.exs`\n\n    def deps do\n      [{:ex_guard, \"~> 1.1.1\", only: :dev}]\n    end","ref":"Mix.Tasks.Guard.html#module-installation","title":"Installation - mix guard","type":"task"},{"doc":"Create .exguard.exs in your root mix directory:\n    use ExGuard.Config\n\n    guard(\"unit-test\")\n    |> command(\"mix test --color\")\n    #config that match specific files:\n    |> watch({~r{lib/(? .+)/(? .+).ex$}, fn(m) -> \"test/#{m[\"dir\"]}/#{m[\"file\"]}_test.exs\" end})\n    #if a file doesn't match with above pattern, this below pattern will be tested and applied\n    |> watch(~r{\\\\.(erl|ex|exs|eex|xrl|yrl)\\\\z}i)\n    |> ignore(~r/priv/)\n\nRun `mix guard` and happy coding.\n\n[Check out here for more fine-grained configs](https://hexdocs.pm/ex_guard/ExGuard.Guard.html).","ref":"Mix.Tasks.Guard.html#module-sample-config-file","title":"Sample config file - mix guard","type":"task"},{"doc":"Notify the result of execution through:\n  * [Terminal Title](http://tldp.org/HOWTO/Xterm-Title-3.html) (Xterm)\n  * [TMux](http://tmux.github.io/) (Universal)\n  * [Terminal Notifier](https://github.com/julienXX/terminal-notifier) (mac only)\n  * [Notify Send](http://ss64.com/bash/notify-send.html) (linux distros)","ref":"Mix.Tasks.Guard.html#module-notifications","title":"Notifications - mix guard","type":"task"},{"doc":"","ref":"Mix.Tasks.Guard.html#execute/1","title":"Mix.Tasks.Guard.execute/1","type":"function"},{"doc":"","ref":"Mix.Tasks.Guard.html#run/1","title":"Mix.Tasks.Guard.run/1","type":"function"}]}